#ifndef _LSAPIBANGS_H_
#include <python.h>
#include <map>
#include <string>
#include <windows.h>
using namespace std;

struct stringicmp {
    bool operator()(const std::string &s1, const std::string &s2) const {
        return (lstrcmpi(s1.c_str(), s2.c_str()) < 0); }
    };
typedef map<string,PyObject *,stringicmp> BangMap;

class LSAPIBangs {
 public:
    static PyObject *AddBangCommand (PyObject *self, PyObject *args);
    static PyObject *AddBangCommandEx (PyObject *self, PyObject *args);
    static PyObject *ParseBangCommand (PyObject *self, PyObject *args);
    static PyObject *RemoveBangCommand (PyObject *self, PyObject *args);

    static LSAPIBangs* Instance (void) {
        if (!bangmgr)
            bangmgr =  new LSAPIBangs ();
        return bangmgr;
    };      

 protected:
    static LSAPIBangs *bangmgr;
    BangMap bangmap;
    void addBang (string bangname, PyObject *pybangfunc);
    void removeBang (string bangname);
    static void dispatchBang (HWND hCaller, const CHAR *command, const CHAR *args);
 
 private:
    LSAPIBangs (void);
    LSAPIBangs (const LSAPIBangs&);
};
#define _LSAPIBANGS_H_B
#endif /*_LSAPIBANGS_H_*/